.\" 
.\" Copyright (c) 1995, 1994, 1993, 1992, 1991, 1990  
.\" Open Software Foundation, Inc. 
.\"  
.\" Permission to use, copy, modify, and distribute this software and 
.\" its documentation for any purpose and without fee is hereby granted, 
.\" provided that the above copyright notice appears in all copies and 
.\" that both the copyright notice and this permission notice appear in 
.\" supporting documentation, and that the name of ("OSF") or Open Software 
.\" Foundation not be used in advertising or publicity pertaining to 
.\" distribution of the software without specific, written prior permission. 
.\"  
.\" OSF DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE 
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
.\" FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL OSF BE LIABLE FOR ANY 
.\" SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
.\" WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN 
.\" ACTION OF CONTRACT, NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING 
.\" OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE 
.\" 
.\"
.\" Mach Operating System
.\" Copyright (c) 1991,1990 Carnegie Mellon University
.\" All Rights Reserved.
.\" 
.\" Permission to use, copy, modify and distribute this software and its
.\" documentation is hereby granted, provided that both the copyright
.\" notice and this permission notice appear in all copies of the
.\" software, derivative works or modified versions, and any portions
.\" thereof, and that both notices appear in supporting documentation.
.\" 
.\" CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS 
.\" CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
.\" ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
.\" 
.\" Carnegie Mellon requests users of this software to return to
.\" 
.\"  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
.\"  School of Computer Science
.\"  Carnegie Mellon University
.\"  Pittsburgh PA 15213-3890
.\" 
.\" any improvements or extensions that they make and grant Carnegie the
.\" rights to redistribute these changes.
.\"
.\" OSF Research Institute MK6.1 (unencumbered) 1/31/1995
.TH VMINFO 1 6/18/90
.CM 4
.SH NAME
vminfo \- display info about a task's address space
.SH SYNOPSIS
\fBvminfo\fP [\fB-host\fP machine] [\fB-v\fP] [\fB-z\fP] [taskid]
.SH DESCRIPTION
\fIvminfo(1)\fR displays information about a task's address space.
The \fItaskid\fP argument, a MachID, specifies the task.
If the \fItaskid\fP argument isn't specified, \fIvminfo\fP displays information
about its own addres space.
.PP
\fIvminfo\fP displays an object name port using the port's MachID.
The MachID is a stable name that persists across invocations
of \fIvminfo\fP.
.PP
\fIvminfo\fP interprets the following options:
.TP 8
.B \-host \fImachine\fR
Directs the inquiry to the \fImachid(1)\fR server running
on the specified machine.
.TP 8
.B \-z
Suspends the target task while querying it for information.
.TP 8
.B \-v
Displays more detailed information.
.SH "SEE ALSO"
ms(1), machid(1), vm_region(2)
